function execute(metricData,javascriptResultSetHelper) {

    var i=0;  					// binding iterator

	var totalTrnxName = {};		// array of Total Transactions Per Interval Metric Name
	var totalTrnxCount = {};	// array of Total Transactions Per Interval Count
	var totalTrnxDefect = {};	// array of Total Defects      Per Interval Count

	var totalBusSvcName = {};	// array of Total Transactions Per Interval Metric Name for Business Service
	var totalBusSvcCount = {};	// array of Total Transactions Per Interval Count for Business Service
	var totalBusSvcDefect = {};	// array of Total Defects      Per Interval Count for Business Service

	var totalAgentName = {};	// array of Total Transactions Per Interval Metric Name for Agent
	var totalAgentCount = {};	// array of Total Transactions Per Interval Count for Agent
	var totalAgentDefect = {};	// array of Total Defects      Per Interval Count for Agent

	var totalTrans   = 0;      // Total Global Count
	var totalDefects = 0;      // Total Global Defects
  
	if(metricData.length == 0) {
		return javascriptResultSetHelper;
	}
	var agentNameForTotal=metricData[0].agentName.processURL // The first agent reporting will get an extra node for grand totals

	// Collects Agent, Metric, and Values from the Input
    for (i=0; i < metricData.length; i++) {
        var metric = metricData[i].agentMetric.attributeURL;
        var agent = metricData[i].agentName.processURL;
        var value = metricData[i].timeslicedValue.value;
        var frequency = metricData[i].frequency;
     	var isAbsent = metricData[i].timeslicedValue.dataIsAbsent();

		// needs only these 2 metrics
        if (((metric.indexOf(":Total Defects Per Interval") > 0) ||
           	 (metric.indexOf(":Total Transactions Per Interval") > 0)) &&
			 (isAbsent == false)) {		// Skip if no data is coming in. Will change to gray.

		    	var BTTopLevel = metric.substring(0, metric.indexOf(":")); // top level path w/o metric name
			var fullBTTree = agent +"|"+ BTTopLevel;		// full path with agent name
			var BusSvcLevelTmp = fullBTTree.substring(0, fullBTTree.lastIndexOf("\|"));
			var BusSvcLevel = BusSvcLevelTmp.substring(0, BusSvcLevelTmp.lastIndexOf("\|"));
			var AgentLevelTmp = BusSvcLevel.substring(0, BusSvcLevel.lastIndexOf("\|"));
			var AgentLevel = AgentLevelTmp.substring(0, AgentLevelTmp.lastIndexOf("\|"));

			// put the Total Transactions Per Interval related values in the right array
			if (metric.indexOf(":Total Transactions Per Interval") > 0) {
				totalTrnxName[fullBTTree] = fullBTTree;	// store Total Transactions Per Interval metric tree
				totalTrnxCount[fullBTTree] = value;
//				log.info("At line 30 - Trnx Count - "+fullBTTree+"|"+value);
				totalBusSvcName[BusSvcLevel] = BusSvcLevel;	// store Total Transactions Per Business Service
//				log.info("At line 38 - totalBusSvcName["+BusSvcLevel+"]="+totalBusSvcName[BusSvcLevel]);
				totalAgentName[AgentLevel] = AgentLevel;	// store Total Transactions Per Agent
				if(isNaN(totalBusSvcCount[BusSvcLevel])) {
					totalBusSvcCount[BusSvcLevel] = value;
				}
				else {
					totalBusSvcCount[BusSvcLevel] += value;
				}
				if(isNaN(totalAgentCount[AgentLevel])) {
					totalAgentCount[AgentLevel] = value;
				}
				else {
					totalAgentCount[AgentLevel] += value;
				}
//				log.info("At line 45 - totalBusSvcCount["+BusSvcLevel+"]="+totalBusSvcCount[BusSvcLevel]);
				totalTrans += value;
			}
			else { // This is for defects then
				totalTrnxDefect[fullBTTree] = value;
				if(isNaN(totalBusSvcDefect[BusSvcLevel])) {
					totalBusSvcDefect[BusSvcLevel] = value;
				}
				else {
					totalBusSvcDefect[BusSvcLevel] += value;
				}
				if(isNaN(totalAgentDefect[AgentLevel])) {
					totalAgentDefect[AgentLevel] = value;
				}
				else {
					totalAgentDefect[AgentLevel] += value;
				}
//				log.info("At line 55 - totalBusSvcDefect["+BusSvcLevel+"]="+totalBusSvcDefect[BusSvcLevel]);
				totalDefects += value;
			}
        }
	}

	// now iterate through Business Transaction metrics and report calculated metrics
	for (var tempMetric in totalTrnxName) {
		var fullBTTree = tempMetric + ":Total Success Pct";

		// Convert to Long

		if (totalTrnxCount[tempMetric] > 0) {
			if(isNaN(totalTrnxDefect[tempMetric])) {
				totalTrnxDefect[tempMetric] = 0;
			}
			var successRatio = (1-(totalTrnxDefect[tempMetric]/(totalTrnxCount[tempMetric]+totalTrnxDefect[tempMetric])))*100;
		}
		else { // This is for defects then
			var successRatio = 100;
		}
                value = Math.round(successRatio)
                var percentSuccess = new java.lang.Long(value);
                

		javascriptResultSetHelper.addMetric(fullBTTree,
			percentSuccess,
			// the result type
			Packages.com.wily.introscope.spec.metric.MetricTypes.kLongFluctuatingCounter,
			frequency);

		
    }
	// now iterate through Business Service Level metrics and report calculated metrics
	for (var tempMetric in totalBusSvcName) {
		var BusSvcLevel = tempMetric + ":Total Success Pct";

		// Convert to Long

		if (totalBusSvcCount[tempMetric] > 0) {
			if(isNaN(totalBusSvcDefect[tempMetric])) {
				totalBusSvcDefect[tempMetric] = 0;
			}
			var successRatio = (1-(totalBusSvcDefect[tempMetric]/(totalBusSvcCount[tempMetric]+totalBusSvcDefect[tempMetric])))*100;
		}
		else { // This is for defects then
			var successRatio = 100;
		}
                value = Math.round(successRatio)
                var percentSuccess = new java.lang.Long(value);
                

		javascriptResultSetHelper.addMetric(BusSvcLevel,
			percentSuccess,
			// the result type
			Packages.com.wily.introscope.spec.metric.MetricTypes.kLongFluctuatingCounter,
			frequency);

		
    }
	// now iterate through Business Service Level metrics and report calculated metrics
	for (var tempMetric in totalBusSvcName) {
		var BusSvcLevel = tempMetric + ":Total Transactions Per Interval";

                var tranCount = new java.lang.Long(totalBusSvcCount[tempMetric]);

		javascriptResultSetHelper.addMetric(BusSvcLevel,
			tranCount,
			// the result type
			Packages.com.wily.introscope.spec.metric.MetricTypes.kLongFluctuatingCounter,
			frequency);

		
    }
	// now iterate through Business Service Level metrics and report calculated metrics
	for (var tempMetric in totalBusSvcName) {
		var BusSvcLevel = tempMetric + ":Total Defects Per Interval";

                var tranDefect = new java.lang.Long(totalBusSvcDefect[tempMetric]);

		javascriptResultSetHelper.addMetric(BusSvcLevel,
			tranDefect,
			// the result type
			Packages.com.wily.introscope.spec.metric.MetricTypes.kLongFluctuatingCounter,
			frequency);

		
    }
	// now iterate through Business Service Level metrics and report calculated metrics
	for (var tempMetric in totalAgentName) {
		var AgentLevel = tempMetric + ":Total Success Pct";

		// Convert to Long

		if (totalAgentCount[tempMetric] > 0) {
			if(isNaN(totalAgentDefect[tempMetric])) {
				totalAgentDefect[tempMetric] = 0;
			}
			var successRatio = (1-(totalAgentDefect[tempMetric]/(totalAgentCount[tempMetric]+totalAgentDefect[tempMetric])))*100;
		}
		else { // This is for defects then
			var successRatio = 100;
		}
                value = Math.round(successRatio)
                var percentSuccess = new java.lang.Long(value);
                

		javascriptResultSetHelper.addMetric(AgentLevel,
			percentSuccess,
			// the result type
			Packages.com.wily.introscope.spec.metric.MetricTypes.kLongFluctuatingCounter,
			frequency);

		
    }
	// now iterate through Business Service Level metrics and report calculated metrics
	for (var tempMetric in totalAgentName) {
		var AgentLevel = tempMetric + ":Total Transactions Per Interval";

                var tranCount = new java.lang.Long(totalAgentCount[tempMetric]);

		javascriptResultSetHelper.addMetric(AgentLevel,
			tranCount,
			// the result type
			Packages.com.wily.introscope.spec.metric.MetricTypes.kLongFluctuatingCounter,
			frequency);

		
    }
	// now iterate through Business Service Level metrics and report calculated metrics
	for (var tempMetric in totalAgentName) {
		var AgentLevel = tempMetric + ":Total Defects Per Interval";

                var tranDefect = new java.lang.Long(totalAgentDefect[tempMetric]);

		javascriptResultSetHelper.addMetric(AgentLevel,
			tranDefect,
			// the result type
			Packages.com.wily.introscope.spec.metric.MetricTypes.kLongFluctuatingCounter,
			frequency);

		
    }

	var metricName = agentNameForTotal + ":CEM Grand Total Transactions Per Interval";

//      Insert Global Totals into a node on the first agent that was examined at start of calculator - Todd Hall 26 May 2015
//	I have nowwhere else to insert it to a valid agent - customer metric agent was tested but was unsuccessful

	javascriptResultSetHelper.addMetric(metricName,
		totalTrans,
		// the result type
		Packages.com.wily.introscope.spec.metric.MetricTypes.kLongFluctuatingCounter,
		frequency);

	var metricName = agentNameForTotal + ":CEM Grand Total Defects Per Interval";

	javascriptResultSetHelper.addMetric(metricName,
		totalDefects,
		// the result type
		Packages.com.wily.introscope.spec.metric.MetricTypes.kLongFluctuatingCounter,
		frequency);

	var metricName = agentNameForTotal+ ":CEM Grand Total Success Pct";

	// Convert to Long

	if (totalTrans > 0) {
		var successRatio = (1-(totalDefects/(totalTrans+totalDefects)))*100;
	}
	else { 
		var successRatio = 100;
	}
	value = Math.round(successRatio)
	var percentSuccess = new java.lang.Long(value);
	

	javascriptResultSetHelper.addMetric(metricName,
		percentSuccess,
		// the result type
		Packages.com.wily.introscope.spec.metric.MetricTypes.kLongFluctuatingCounter,
		frequency);

    // return the result set
    return javascriptResultSetHelper;
}

function getAgentRegex() {
    return "(.*)\\|CEM\\|(.*)";
}
function getMetricRegex() {
    return "Business Service\\|([^\|:]*)\\|Business Transactions\\|([^\|:]*).*";
}

// must return a multiple of default system frequency (currently 15 seconds)
function getFrequency() {
	return 1 * Packages.com.wily.introscope.spec.metric.Frequency.kDefaultSystemFrequencyInSeconds;
}

//Return false if the script should not run on the MOM.
//Scripts that create metrics on agents other than the Custom Metric Agent
//should not run on the MOM because the agents exist only in the Collectors.
//Default is true.
function runOnMOM() 
{
	return false;
}
